



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WPF中异步更新UI元素</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WPF中异步更新UI元素</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 02:21:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>XAML</p>
<p>界面很简单，只有一个按钮和一个lable元素，要实现点击button时，lable的内容从0开始自动递增。</p>
<div>
<pre class="prettyprint linenums">&lt;Grid&gt;<br />
    &lt;Label Name="lable_plus" Content="0"/&gt;<br />
    &lt;Button Content="Button"  Click="button_Click" Height="23"  Name="button" Width="75" /&gt;<br />
&lt;/Grid&gt;</pre>
</div>
<p>C#</p>
<div>
<pre class="prettyprint linenums">private void button_Click(object sender, RoutedEventArgs e)<br />
{<br />
     for (int i = ; i &lt; ; i++)<br />
     {<br />
         lable_plus.Content = i;<br />
     }<br />
}</pre>
</div>
<p>上面的代码执行后会发现，点击按钮并不会看到；lable中数字递增，而是稍等片刻后，直接出现99999。原因在于UI线程被阻塞用以计算循环 i++ 了。</p>
<p><strong>方法一：</strong></p>
<div>
<pre class="prettyprint linenums">private void te_Click(object sender, RoutedEventArgs e)<br />
{<br />
       update();<br />
}

public delegate void PlusNumberDelegate(int i);

private void update()<br />
{<br />
      for (int i = ; i &lt; ; i++)<br />
     {<br />
           this.lable_plus.Dispatcher.BeginInvoke(<br />
                    DispatcherPriority.SystemIdle,<br />
           new NextNumber(this.plus),i);<br />
     }<br />
}</pre>
</div>
<p>参考 http://msdn.microsoft.com/zh-cn/library/ms741870.aspx</p>
<p><strong>方法二：</strong></p>
<p>实得分</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8okjl9z.html">UWP中新加的数据绑定方式x&colon;Bind分析总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pdwny9.html">js基础总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/390m0pm8.html">mybatis map常用数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jpeyw9.html">ROS学习笔记（三）&mdash;&mdash;ROS安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mrm3o9.html">Oracle SQL 优化原则&lpar;实用篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9py7xd9.html">操作PDF文件的关键技术点</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rveo78.html">Load xlsx in a  folder to RDBMS table with Talend</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2rre8.html">【NDK开发】使用NDK开发android</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmjvn09.html">echart 图表 在&period;net中生成图片的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zyn28.html">关于aspx 页面生成html 源码顶部空行不得不说的事儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yeozjq.html">U3D 自带navmesh自动寻路教学</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzd5o08.html">加密代理和Retrofit解密Converter</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1j1pxq.html">HTML5 全屏 API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmp6v8.html">FLASK简单入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2m0noq.html">Oracle 生成工作日历表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv12x28.html">nodejs连接阿里云物联网套件&lpar;mqtt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvd6p38.html">airflow整体架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oo6l18.html">Hangfire定时任务设置CronExpression表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zykmox9.html">【原创】Innodb中mysql如何快速删除2T的大表</a>
		</li>
						<li><a href="https://www.batexi.com/a/96036l39.html">java并发线程池---了解ThreadPoolExecutor就够了</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93xng93.html">在一个空ASP&period;NET Web项目上创建一个ASP&period;NET Web API 2&period;0应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8me6pqk.html">HTML骨架结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8em7z91.html">js报错： Uncaught RangeError&colon; Invalid string length</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnn3kqr.html">基于fis3的组件可视化道路</a>
			</li>
						<li><a href="https://www.batexi.com/a/495p16qz.html">【夯实Mysql基础】MySQL性能优化的21个最佳实践 和 mysql使用索引</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e5xk81.html">ExecuteOrDelayUntilScriptLoaded 还是 SP&period;SOD&period;executeFunc？</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g52787.html">基于注解的Spring多数据源配置和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7d3jqe.html">Mono 4&period;0 Mac上运行asp&period;net mvc 5&period;2&period;3</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlwo68o.html">Lesson 24 It could be worse</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1yezqg.html">企业IT管理员IE11升级指南【15】&mdash;&mdash; 代理自动配置脚本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
